declare const _default: {
    locale: string;
    common: {
        searchPlaceholder: string;
        noData: string;
        noRecordsFound: string;
        btnConfirm: string;
        loading: string;
        checkAll: string;
        btnOk: string;
        btnCancel: string;
        btnClose: string;
        btnClickMe: string;
        copied: string;
    };
    autoComplete: {
        latestInput: string;
    };
    datatable: {
        tableSetting: string;
        ensure: string;
        cancel: string;
        compact: string;
        standard: string;
        loose: string;
        divideLine: string;
        striped: string;
        tableShadow: string;
        styles: string;
        colSelected: string;
        colCanSelect: string;
    };
    datePicker: {
        today: string;
        clear: string;
        daysOfWeek: string[];
        monthsOfYear: string[];
        startDate: string;
        endDate: string;
        yearDisplay(year: any): string;
    };
    datePickerPro: {
        placeholder: string;
        startPlaceholder: string;
        endPlaceholder: string;
        daysOfWeek: string[];
        monthsOfYear: string[];
        getYearMonthStr(year: any, month: any): string;
        hour: string;
        min: string;
        second: string;
        yearDisplay(year: any): string;
    };
    form: {
        required(val: any): string;
        minlength(len: any): string;
        maxlength(len: any): string;
        min(val: any): string;
        max(val: any): string;
        requiredTrue(val: any): string;
        email(val: any): string;
        whitespace(val: any): string;
    };
    gantt: {
        today: string;
        day: string;
        week: string;
        month: string;
        milestone: string;
        monthsOfYear: string[];
        yearDisplay(year: any): string;
        monthDisplay(strMonthIndex: string): any;
        yearAndMonthDisplay(year: string, strMonthIndex: string): any;
    };
    pagination: {
        goTo: string;
        pageSize: string;
        page: string;
        perPage: string;
        totalItem(total: any): string;
    };
    quadrant: {
        xAxisLabel: string;
        yAxisLabel: string;
        defaultTitleConf: {
            title: string;
        }[];
    };
    upload: {
        warning: string;
        upload: string;
        chooseFile: string;
        chooseFiles: string;
        preload: string;
        uploading: string;
        uploaded: string;
        uploadFailed: string;
        uploadSuccess: string;
        delete: string;
        reUpload: string;
        cancelUpload: string;
        getNotAllowedFileTypeMsg(filename: any, scope: any): string;
        getBeyondMaximalFileSizeMsg(filename: any, maximalSize: any): string;
        getAllFilesBeyondMaximalFileSizeMsg(maximalSize: any): string;
        getExistSameNameFilesMsg(sameNames: any): string;
        getSelectedFilesCount(filesCount: any): string;
        getUploadingFilesCount(uploadingCount: any, filesCount: any): string;
        getFailedFilesCount(failedCount: any): string;
    };
    modal: {
        warning: string;
        error: string;
        fail: string;
        info: string;
        success: string;
    };
    imagePreview: {
        rotate: string;
        zoomIn: string;
        zoomOut: string;
        bestScale: string;
        originScale: string;
        pre: string;
        next: string;
        origin: string;
        download: string;
    };
    colorPicker: {
        recentlyUsed: string;
        basicColors: string;
        moreColors: string;
    };
    stepsGuide: {
        previous: string;
        next: string;
        finish: string;
    };
    splitter: {
        collapse: string;
        expand: string;
    };
    relativeTime: {
        yearsAgo(num: number): string;
        monthsAgo(num: number): string;
        weeksAgo(num: number): string;
        daysAgo(num: number): string;
        daysLater(num: number): string;
        weeksLater(num: number): string;
        monthsLater(num: number): string;
        yearsLater(num: number): string;
        hoursAgo: string;
        minutesAgo: string;
        justnow: string;
        later: string;
        minutesLater: string;
        hoursLater: string;
    };
    tagsInput: {
        tagsReachMaxLength: string;
        tagsReachMaxNumber: string;
    };
    categorySearch: {
        confirm: string;
        cancel: string;
        selectFilterCondition: string;
        getFindingMessage(msg: any): string;
        getSearchMessage(type: any): string;
        saveFilter: string;
        filterTitle: string;
        placeholder: string;
        searchPlaceholder: string;
        noFilterConditions: string;
        clearFilterCondition: string;
        seeMore: string;
        selected: string;
        switchToStart: string;
        switchToEnd: string;
        keyword: string;
    };
    userGuide: {
        guide: string;
        prev: string;
        next: string;
        finish: string;
        autoFill: string;
    };
};
export default _default;
