import { EventEmitter, TemplateRef } from '@angular/core';
import { ToggleMenuListItem } from './toggle-menu.type';
import * as i0 from "@angular/core";
export declare class ToggleMenuListItemComponent {
    item: ToggleMenuListItem;
    index: number;
    selectIndex: number;
    activeIndex: number;
    /**
     * 【可选】决定下拉框每项文字如何显示，默认显示filterKey字段或者本身的值
     */
    formatter: (item: any) => string;
    /**
     * 【当传入资源（options）类型为Array<{key: value}，必选】针对传入资源options的每项对应字段做过滤操作
     */
    filterKey: string;
    /**
     * 【当传入资源（options）类型为Array<{key: value}，必选】针对传入资源options的每项对应字段做禁用操作的key
     */
    optionDisabledKey: string;
    /**
     * 【当传入资源（options）类型为Array<{key: value}，可选】如使用分组需设置
     */
    optionGroupKey: string;
    /**
     * 【可选】是否允许高亮选项
     */
    highlightToggle: boolean;
    /**
     * 【可选】下拉高亮css
     */
    highlightItemClass: string;
    /**
     * 【可选】是否支持多选
     */
    multiple: boolean;
    /**
     * 【可选】是否需要关键字高亮显示
     */
    isShowKeyword: boolean;
    /**
     * 【可选】auto-complete 中需要高亮显示的关键字
     */
    keyword: string;
    customTemplate: TemplateRef<any>;
    color: string;
    chooseItem: EventEmitter<any>;
    constructor();
    choose(option: any, index: any, event?: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ToggleMenuListItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ToggleMenuListItemComponent, "d-toggle-menu-list-item", never, { "item": "item"; "index": "index"; "selectIndex": "selectIndex"; "activeIndex": "activeIndex"; "formatter": "formatter"; "filterKey": "filterKey"; "optionDisabledKey": "optionDisabledKey"; "optionGroupKey": "optionGroupKey"; "highlightToggle": "highlightToggle"; "highlightItemClass": "highlightItemClass"; "multiple": "multiple"; "isShowKeyword": "isShowKeyword"; "keyword": "keyword"; "customTemplate": "customTemplate"; "color": "color"; }, { "chooseItem": "chooseItem"; }, never, never, false, never>;
}
