export declare class IUploadOptions {
    isChunked?: boolean;
    chunkSize?: number;
    uri: string;
    method?: string;
    maximumSize?: number;
    headers?: {
        [key: string]: any;
    };
    authToken?: string;
    authTokenHeader?: string;
    additionalParameter?: {
        [key: string]: any;
    };
    fileFieldName?: string;
    checkSameName?: boolean;
    withCredentials?: boolean;
    responseType?: 'arraybuffer' | 'blob' | 'json' | 'text';
}
export declare class IFileOptions {
    accept?: string;
    multiple?: boolean;
    webkitdirectory?: boolean;
}
export declare enum UploadStatus {
    preLoad = 0,
    uploading = 1,
    uploaded = 2,
    failed = 3
}
