import { OnDestroy, OnInit, TemplateRef } from '@angular/core';
import { I18nInterface, I18nService } from 'ng-devui/i18n';
import { Subscription } from 'rxjs';
import { UserGuideCoreService } from './user-guide-core.service';
import { IUserGuideExtraConfig } from './user-guide.types';
import { IButtonStyle } from 'ng-devui/button';
import * as i0 from "@angular/core";
export declare class UserGuideUIComponent implements OnInit, OnDestroy {
    private userGuideCoreService;
    private i18n;
    i18nCommonText: I18nInterface['userGuide'];
    i18nSubscription: Subscription;
    showDots: boolean;
    maxContentWidth: number;
    isCover: boolean;
    extraConfig: IUserGuideExtraConfig;
    stepsLength: number;
    currentStep: number;
    curStepType: string;
    title: string;
    content: string | TemplateRef<any>;
    canNext: boolean;
    canPrev: boolean;
    canFinish: boolean;
    showMaskLayer: boolean;
    showNormalOverlay: boolean;
    showTopOverlay: boolean;
    showBottomOverlay: boolean;
    showLeftOverlay: boolean;
    showRightOverlay: boolean;
    showBorder: boolean;
    showButtons: boolean;
    showOperateZone: boolean;
    showPrevButton: boolean;
    items: any[];
    get contentTemplate(): TemplateRef<any>;
    get nextButtonType(): IButtonStyle;
    constructor(userGuideCoreService: UserGuideCoreService, i18n: I18nService);
    ngOnInit(): void;
    next(): void;
    prev(): void;
    exit(): void;
    close(): void;
    switchStep(index: any): void;
    disableClick(event: any): void;
    isTemplateContent(): boolean;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<UserGuideUIComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<UserGuideUIComponent, "d-user-guide-ui", never, { "showDots": "showDots"; "maxContentWidth": "maxContentWidth"; "isCover": "isCover"; "extraConfig": "extraConfig"; }, {}, never, never, false, never>;
}
